class ComponentPanelLeft extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            project: props.project
        };

        document.addEventListener(UPDATE_STATE_FRONTEND, this.updateStateFrontend);
    }

     updateStateFrontend = (event) => {
        try {
            this.setState({
                project: event.detail
            });
        } catch (e) {
            alert(e.message);
        }
    }

    onAdcTakeOff = () => {
        eel.adc_take_off()
    }

    onAdcLand = () => {
        eel.adc_land()
    }

    onAdcYawLeft = () => {
        let angle = prompt('Enter angle in degrees to yaw left:')
        eel.adc_yaw(-angle);
    }

    onAdcYawRight = () => {
        let angle = prompt('Enter angle in degrees to yaw right:')
        eel.adc_yaw(angle);
    }

    onAdcResetRovio = () => {
        eel.adc_reset_rovio();
    }

    onAdcClearMap = () => {
        eel.adc_clear_map();
    }

    onAdcStopAll = () => {
        eel.adc_stop()
        this.props.onStopFlightPlanExecution();
    }

    render = () => {
        return (
            <div className="panel-left">
                <div id="panel-left-scrollable">
                    <div className="panel-logo"></div>
                    <ComponentPanelSide title="Layers" isOpened={true}>
                        <FormControlLabel
                            control={<Checkbox
                                checked={this.state.project.view_settings.is_layer_pointcloud_raw}
                                onChange={(event) => {
                                    this.state.project.view_settings.is_layer_pointcloud_raw = event.target.checked;
                                    this.props.onUpdateProject(this.state.project);
                                }}
                            />}
                            label="Raw pointcloud"/><br/>
                        <FormControlLabel
                            control={<Checkbox
                                checked={this.state.project.view_settings.is_layer_pointcloud_filtered}
                                onChange={(event) => {
                                    this.state.project.view_settings.is_layer_pointcloud_filtered = event.target.checked;
                                    this.setState({
                                        project: {...this.state.project}
                                    });
                                    this.props.onUpdateProject(this.state.project);
                                }}
                            />}
                            label="Filtered pointcloud"/><br/>
                        <FormControlLabel
                            control={<Checkbox
                                checked={this.state.project.view_settings.is_layer_walls}
                                onChange={(event) => {
                                    this.state.project.view_settings.is_layer_walls = event.target.checked;
                                    this.setState({
                                        project: {...this.state.project}
                                    });
                                    this.props.onUpdateProject(this.state.project);
                                }}
                            />}
                            label="Walls"/><br/>
                        <FormControlLabel
                            control={<Checkbox
                                checked={this.state.project.view_settings.is_layer_flight_path}
                                onChange={(event) => {
                                    this.state.project.view_settings.is_layer_flight_path = event.target.checked;
                                    this.setState({
                                        project: {...this.state.project}
                                    });
                                    this.props.onUpdateProject(this.state.project);
                                }}
                            />}
                            label="Flight path"/><br/>
                        <FormControlLabel
                            control={<Checkbox
                                checked={this.state.project.view_settings.is_layer_poi}
                                onChange={(event) => {
                                    this.state.project.view_settings.is_layer_poi = event.target.checked;
                                    if (!this.state.project.view_settings.is_layer_poi) {
                                        this.state.project.view_settings.is_snap_to_flight_path_poi = false;
                                    }
                                    this.setState({
                                        project: {...this.state.project}
                                    });
                                    this.props.onUpdateProject(this.state.project);
                                }}
                            />}
                            label="Points of interest"/>
                    </ComponentPanelSide>
                    <ComponentPanelSide title="Points of interest" isOpened={true}>
                        <ComponentPanelPOIs
                            project={this.state.project}
                            isSnapToFlightPath={this.state.project.view_settings.is_snap_to_flight_path_poi}
                            onSnapToFlightPathChange={(event) => {
                                this.state.project.view_settings.is_snap_to_flight_path_poi = event.target.checked;
                                if (this.state.project.view_settings.is_snap_to_flight_path_poi) {
                                    this.state.project.view_settings.is_layer_flight_path = true;
                                }
                                this.setState({
                                    project: {...this.state.project}
                                });
                                this.props.onUpdateProject(this.state.project);
                            }}
                            onDialogLoadFlightPlan={() => {
                                this.props.onDialogLoadFlightPlan();
                            }}
                            onDialogSavePOI={() => {
                                this.props.onDialogSavePOI();
                            }}
                            onDialogDeletePOI={() => {
                                this.props.onDialogDeletePOI();
                            }}
                            onDialogClearAllPOIs={() => {
                                this.props.onDialogClearAllPOIs();
                            }}
                        />
                    </ComponentPanelSide>
                    <ComponentPanelSide title="Status" isOpened={true}>
                        <ComponentPanelStatusSide/>
                    </ComponentPanelSide>
                </div>
                <div id="panel-left-bottom">
                    <div className="row-buttons">
                        <Button variant="contained" style={{marginBottom: 5}} onClick={this.onAdcTakeOff}>Take
                            off</Button>
                        <Button variant="contained" style={{marginBottom: 5}} onClick={this.onAdcLand}>Land</Button>
                    </div>
                    <div className="clear"/>
                    <div className="row-buttons">
                        <Button variant="contained" style={{marginBottom: 5}} onClick={this.onAdcYawLeft}>Yaw
                            left</Button>
                        <Button variant="contained" style={{marginBottom: 5}} onClick={this.onAdcYawRight}>Yaw
                            right</Button>
                    </div>
                    <div className="clear"/>
                    <div className="row-buttons">
                        <Button
                            variant="contained"
                            style={{marginBottom: 5}}
                            onClick={this.onAdcResetRovio}>
                            Reset ROVIO</Button>
                        <Button
                            variant="contained"
                            style={{marginBottom: 5}}
                            onClick={this.onAdcClearMap}>
                            Clear Map</Button>
                    </div>
                    <div className="clear"/>
                    <div className="row-buttons">
                        <Button
                            id="button-stop-all"
                            variant="contained"
                            style={{marginBottom: 5}}
                            onClick={this.onAdcStopAll}>
                            Stop</Button>
                    </div>
                </div>
            </div>);
    }
}

