class DialogDeletePOIs extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            message: "Are you sure you want to delete the selected POI",
        };
    };

    onClose = () => {
        this.props.onClose();
    }

    onOk = () => {
        if (this.props.clearAllPOIs) {
            document.dispatchEvent(new CustomEvent(POI_DELETE_ALL, {detail: {}}));
        } else {
            document.dispatchEvent(new CustomEvent(POI_DELETE_ACTIVE, {detail: {}}));
        }
        this.onClose();
    }

    render = () => {
        const style = {
            width: 450,
            backgroundColor: "#f3f3f3",
            border: '2px solid #000',
            borderTop: 0,
            p: 4,
            borderRadius: "0 0 18px 18px",
        };

        const contain_style = {
            position: 'absolute',
            top: '50%',
            left: '50%',
            width: "auto",
            transform: 'translate(-50%, -50%)',
        }

        const title_bar_style = {
            fontSize: "102%",
            fontFamily: 'Space Grotesk',
            fontWeight: "600",
            letterSpacing: "0.5px",
            lineHeight: "25px",
            textAlign: "center",
            width: 450,
            backgroundColor: "#fff",
            border: '2px solid #000',
            borderBottom: 0,
            p: 1,
            borderRadius: "18px 18px 0 0",
        }

        return (
            <Modal
                open={this.props.isOpen}
                onClose={this.onClose}>
                <Grid container spacing={0} alignItems="center" direction="column" style={contain_style}>
                    <Grid item sx={title_bar_style}>`Delete {this.props.clearAllPOIs ? "all POIs" : "POI"}`</Grid>
                    <Grid item sx={style}>
                        <div style={{fontSize: "115%", textAlign: "center"}}>
                            {
                                this.props.clearAllPOIs ?
                                "Are you sure you want to delete all POIs?"
                                :
                                this.state.message
                            }
                        </div>
                        <Button variant="action" onClick={this.onClose}>Cancel</Button>
                        <Button variant="action" onClick={this.onOk}>Confirm</Button>
                    </Grid>
                </Grid>
            </Modal>
        )
    }
}